diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/credits.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/credits.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/credits.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/credits.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 30,36 ****
  		if ( ! is_array( $results ) )
  			return false;
  
! 		set_site_transient( 'wordpress_credits_' . $locale, $results, 86400 ); // One day
  	}
  
  	return $results;
--- 30,36 ----
  		if ( ! is_array( $results ) )
  			return false;
  
! 		set_site_transient( 'wordpress_credits_' . $locale, $results, DAY_IN_SECONDS );
  	}
  
  	return $results;
***************
*** 52,58 ****
  
  <h1><?php printf( __( 'Welcome to WordPress %s' ), $display_version ); ?></h1>
  
! <div class="about-text"><?php printf( __( 'Thank you for updating to the latest version! WordPress %s is already making your website better, faster, and more attractive, just like you!' ), $display_version ); ?></div>
  
  <div class="wp-badge"><?php printf( __( 'Version %s' ), $display_version ); ?></div>
  
--- 52,58 ----
  
  <h1><?php printf( __( 'Welcome to WordPress %s' ), $display_version ); ?></h1>
  
! <div class="about-text"><?php printf( __( 'Thank you for updating to the latest version! WordPress %s is more polished and enjoyable than ever before. We hope you like it.' ), $display_version ); ?></div>
  
  <div class="wp-badge"><?php printf( __( 'Version %s' ), $display_version ); ?></div>
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/custom-background.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/custom-background.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/custom-background.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/custom-background.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 73,84 ****
  		add_action("load-$page", array(&$this, 'take_action'), 49);
  		add_action("load-$page", array(&$this, 'handle_upload'), 49);
  
- 		if ( isset( $_REQUEST['context'] ) && $_REQUEST['context'] == 'custom-background' ) {
- 			add_filter( 'attachment_fields_to_edit', array( $this, 'attachment_fields_to_edit' ), 10, 2 );
- 			add_filter( 'media_upload_tabs', array( $this, 'filter_upload_tabs' ) );
- 			add_filter( 'media_upload_mime_type_links', '__return_empty_array' );
- 		}
- 
  		if ( $this->admin_header_callback )
  			add_action("admin_head-$page", $this->admin_header_callback, 51);
  	}
--- 73,78 ----
***************
*** 94,101 ****
  			'title'   => __('Overview'),
  			'content' =>
  				'<p>' . __( 'You can customize the look of your site without touching any of your theme&#8217;s code by using a custom background. Your background can be an image or a color.' ) . '</p>' .
! 				'<p>' . __( 'To use a background image, simply upload it, then choose your display options below. You can display a single instance of your image, or tile it to fill the screen. You can have your background fixed in place, so your site content moves on top of it, or you can have it scroll with your site.' ) . '</p>' .
! 				'<p>' . __( 'You can also choose a background color. If you know the hexadecimal code for the color you want, enter it in the Background Color field. If not, click on the Select a Color link, and a color picker will allow you to choose the exact shade you want.' ) . '</p>' .
  				'<p>' . __( 'Don&#8217;t forget to click on the Save Changes button when you are finished.' ) . '</p>'
  		) );
  
--- 88,95 ----
  			'title'   => __('Overview'),
  			'content' =>
  				'<p>' . __( 'You can customize the look of your site without touching any of your theme&#8217;s code by using a custom background. Your background can be an image or a color.' ) . '</p>' .
! 				'<p>' . __( 'To use a background image, simply upload it or choose an image that has already been uploaded to your Media Library by clicking the &#8220;Choose Image&#8221; button. You can display a single instance of your image, or tile it to fill the screen. You can have your background fixed in place, so your site content moves on top of it, or you can have it scroll with your site.' ) . '</p>' .
! 				'<p>' . __( 'You can also choose a background color by clicking the Select Color button and either typing in a legitimate HTML hex value, e.g. &#8220;#ff0000&#8221; for red, or by choosing a color using the color picker.' ) . '</p>' .
  				'<p>' . __( 'Don&#8217;t forget to click on the Save Changes button when you are finished.' ) . '</p>'
  		) );
  
***************
*** 105,114 ****
  			'<p>' . __( '<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>' ) . '</p>'
  		);
  
! 		add_thickbox();
! 		wp_enqueue_script('media-upload');
  		wp_enqueue_script('custom-background');
! 		wp_enqueue_style('farbtastic');
  	}
  
  	/**
--- 99,107 ----
  			'<p>' . __( '<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>' ) . '</p>'
  		);
  
! 		wp_enqueue_media();
  		wp_enqueue_script('custom-background');
! 		wp_enqueue_style('wp-color-picker');
  	}
  
  	/**
***************
*** 254,260 ****
  <?php endif; ?>
  <tr valign="top">
  <th scope="row"><?php _e('Select Image'); ?></th>
! <td><form enctype="multipart/form-data" id="upload-form" method="post" action="">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
--- 247,253 ----
  <?php endif; ?>
  <tr valign="top">
  <th scope="row"><?php _e('Select Image'); ?></th>
! <td><form enctype="multipart/form-data" id="upload-form" class="wp-upload-form" method="post" action="">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
***************
*** 262,275 ****
  		<?php wp_nonce_field( 'custom-background-upload', '_wpnonce-custom-background-upload' ); ?>
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
- 	<?php
- 		$image_library_url = get_upload_iframe_src( 'image', null, 'library' );
- 		$image_library_url = remove_query_arg( 'TB_iframe', $image_library_url );
- 		$image_library_url = add_query_arg( array( 'context' => 'custom-background', 'TB_iframe' => 1 ), $image_library_url );
- 	?>
  	<p>
  		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
! 		<a id="choose-from-library-link" class="button thickbox" href="<?php echo esc_url( $image_library_url ); ?>"><?php _e( 'Choose Image' ); ?></a>
  	</p>
  	</form>
  </td>
--- 255,265 ----
  		<?php wp_nonce_field( 'custom-background-upload', '_wpnonce-custom-background-upload' ); ?>
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
  	<p>
  		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
! 		<a id="choose-from-library-link" class="button"
! 			data-choose="<?php esc_attr_e( 'Choose a Background Image' ); ?>"
! 			data-update="<?php esc_attr_e( 'Set as background' ); ?>"><?php _e( 'Choose Image' ); ?></a>
  	</p>
  	</form>
  </td>
***************
*** 327,337 ****
  <tr valign="top">
  <th scope="row"><?php _e( 'Background Color' ); ?></th>
  <td><fieldset><legend class="screen-reader-text"><span><?php _e( 'Background Color' ); ?></span></legend>
! <?php $show_clear = get_theme_mod('background_color') ? '' : ' style="display:none"'; ?>
! <input type="text" name="background-color" id="background-color" value="#<?php echo esc_attr(get_background_color()) ?>" />
! <a class="hide-if-no-js" href="#" id="pickcolor"><?php _e('Select a Color'); ?></a> <span<?php echo $show_clear; ?> class="hide-if-no-js" id="clearcolor"> (<a href="#"><?php current_theme_supports( 'custom-background', 'default-color' ) ? _e( 'Default' ) : _e( 'Clear' ); ?></a>)</span>
! <input type="hidden" id="defaultcolor" value="<?php if ( current_theme_supports( 'custom-background', 'default-color' ) ) echo '#' . esc_attr( get_theme_support( 'custom-background', 'default-color' ) ); ?>" />
! <div id="colorPickerDiv" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
  </fieldset></td>
  </tr>
  </tbody>
--- 317,328 ----
  <tr valign="top">
  <th scope="row"><?php _e( 'Background Color' ); ?></th>
  <td><fieldset><legend class="screen-reader-text"><span><?php _e( 'Background Color' ); ?></span></legend>
! <?php
! $default_color = '';
! if ( current_theme_supports( 'custom-background', 'default-color' ) )
! 	$default_color = ' data-default-color="#' . esc_attr( get_theme_support( 'custom-background', 'default-color' ) ) . '"';
! ?>
! <input type="text" name="background-color" id="background-color" value="#<?php echo esc_attr( get_background_color() ); ?>"<?php echo $default_color ?> />
  </fieldset></td>
  </tr>
  </tbody>
***************
*** 357,363 ****
  
  		check_admin_referer('custom-background-upload', '_wpnonce-custom-background-upload');
  		$overrides = array('test_form' => false);
! 		$file = wp_handle_upload($_FILES['import'], $overrides);
  
  		if ( isset($file['error']) )
  			wp_die( $file['error'] );
--- 348,360 ----
  
  		check_admin_referer('custom-background-upload', '_wpnonce-custom-background-upload');
  		$overrides = array('test_form' => false);
! 
! 		$uploaded_file = $_FILES['import'];
! 		$wp_filetype = wp_check_filetype_and_ext( $uploaded_file['tmp_name'], $uploaded_file['name'], false );
! 		if ( ! wp_match_mime_types( 'image', $wp_filetype['type'] ) )
! 			wp_die( __( 'The uploaded file is not a valid image. Please try again.' ) );
! 
! 		$file = wp_handle_upload($uploaded_file, $overrides);
  
  		if ( isset($file['error']) )
  			wp_die( $file['error'] );
***************
*** 393,417 ****
  	}
  
  	/**
! 	 * Replace default attachment actions with "Set as background" link.
  	 *
  	 * @since 3.4.0
  	 */
! 	function attachment_fields_to_edit( $form_fields, $post ) {
! 		$form_fields = array( 'image-size' => $form_fields['image-size'] );
! 		$form_fields['buttons'] = array( 'tr' => '<tr class="submit"><td></td><td><a data-attachment-id="' . $post->ID . '" class="wp-set-background">' . __( 'Set as background' ) . '</a></td></tr>' );
! 		$form_fields['context'] = array( 'input' => 'hidden', 'value' => 'custom-background' );
! 
  		return $form_fields;
  	}
  
  	/**
! 	 * Leave only "Media Library" tab in the uploader window.
  	 *
  	 * @since 3.4.0
  	 */
! 	function filter_upload_tabs() {
! 		return array( 'library' => __('Media Library') );
  	}
  
  	public function wp_set_background_image() {
--- 390,410 ----
  	}
  
  	/**
! 	 * Unused since 3.5.0.
  	 *
  	 * @since 3.4.0
  	 */
! 	function attachment_fields_to_edit( $form_fields ) {
  		return $form_fields;
  	}
  
  	/**
! 	 * Unused since 3.5.0.
  	 *
  	 * @since 3.4.0
  	 */
! 	function filter_upload_tabs( $tabs ) {
! 		return $tabs;
  	}
  
  	public function wp_set_background_image() {
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/custom-header.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/custom-header.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/custom-header.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/custom-header.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 93,104 ****
  		add_action("admin_head-$page", array(&$this, 'js'), 50);
  		if ( $this->admin_header_callback )
  			add_action("admin_head-$page", $this->admin_header_callback, 51);
- 
- 		if ( isset( $_REQUEST['context'] ) && $_REQUEST['context'] == 'custom-header' ) {
- 			add_filter( 'attachment_fields_to_edit', array( $this, 'attachment_fields_to_edit' ), 10, 2 );
- 			add_filter( 'media_upload_tabs', array( $this, 'filter_upload_tabs' ) );
- 			add_filter( 'media_upload_mime_type_links', '__return_empty_array' );
- 		}
  	}
  
  	/**
--- 93,98 ----
***************
*** 130,137 ****
  			'title'   => __('Header Text'),
  			'content' =>
  				'<p>' . sprintf( __( 'For most themes, the header text is your Site Title and Tagline, as defined in the <a href="%1$s">General Settings</a> section.' ), admin_url( 'options-general.php' ) ) . '<p>' .
! 				'<p>' . __( 'In the Header Text section of this page, you can choose whether to display this text or hide it. You can also choose a color for the text by typing in a legitimate HTML hex value (eg: &#8220;#ff0000&#8221; for red) or by clicking &#8220;Select a Color&#8221; and dialing in a color using the color picker.') . '</p>' .
! 				'<p>' . __( 'Don&#8217;t forget to Save Changes when you&#8217;re done!') . '</p>'
  		) );
  
  		get_current_screen()->set_help_sidebar(
--- 124,131 ----
  			'title'   => __('Header Text'),
  			'content' =>
  				'<p>' . sprintf( __( 'For most themes, the header text is your Site Title and Tagline, as defined in the <a href="%1$s">General Settings</a> section.' ), admin_url( 'options-general.php' ) ) . '<p>' .
! 				'<p>' . __( 'In the Header Text section of this page, you can choose whether to display this text or hide it. You can also choose a color for the text by clicking the Select Color button and either typing in a legitimate HTML hex value, e.g. &#8220;#ff0000&#8221; for red, or by choosing a color using the color picker.' ) . '</p>' .
! 				'<p>' . __( 'Don&#8217;t forget to click &#8220;Save Changes&#8221; when you&#8217;re done!') . '</p>'
  		) );
  
  		get_current_screen()->set_help_sidebar(
***************
*** 171,181 ****
  		$step = $this->step();
  
  		if ( ( 1 == $step || 3 == $step ) ) {
! 			add_thickbox();
! 			wp_enqueue_script( 'media-upload' );
  			wp_enqueue_script( 'custom-header' );
  			if ( current_theme_supports( 'custom-header', 'header-text' ) )
! 				wp_enqueue_script('farbtastic');
  		} elseif ( 2 == $step ) {
  			wp_enqueue_script('imgareaselect');
  		}
--- 165,174 ----
  		$step = $this->step();
  
  		if ( ( 1 == $step || 3 == $step ) ) {
! 			wp_enqueue_media();
  			wp_enqueue_script( 'custom-header' );
  			if ( current_theme_supports( 'custom-header', 'header-text' ) )
! 				wp_enqueue_script( 'wp-color-picker' );
  		} elseif ( 2 == $step ) {
  			wp_enqueue_script('imgareaselect');
  		}
***************
*** 190,196 ****
  		$step = $this->step();
  
  		if ( ( 1 == $step || 3 == $step ) && current_theme_supports( 'custom-header', 'header-text' ) )
! 			wp_enqueue_style('farbtastic');
  		elseif ( 2 == $step )
  			wp_enqueue_style('imgareaselect');
  	}
--- 183,189 ----
  		$step = $this->step();
  
  		if ( ( 1 == $step || 3 == $step ) && current_theme_supports( 'custom-header', 'header-text' ) )
! 			wp_enqueue_style( 'wp-color-picker' );
  		elseif ( 2 == $step )
  			wp_enqueue_style('imgareaselect');
  	}
***************
*** 215,226 ****
  			return;
  		}
  
- 		if ( isset( $_POST['resettext'] ) ) {
- 			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
- 			remove_theme_mod('header_textcolor');
- 			return;
- 		}
- 
  		if ( isset( $_POST['removeheader'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
  			$this->remove_header_image();
--- 208,213 ----
***************
*** 332,338 ****
  	function js_1() { ?>
  <script type="text/javascript">
  /* <![CDATA[ */
- var farbtastic;
  (function($){
  	var default_color = '#<?php echo get_theme_support( 'custom-header', 'default-text-color' ); ?>',
  		header_text_fields;
--- 319,324 ----
***************
*** 341,347 ****
  		$('#name').css('color', color);
  		$('#desc').css('color', color);
  		$('#text-color').val(color);
- 		farbtastic.setColor(color);
  	}
  
  	function toggle_text() {
--- 327,332 ----
***************
*** 360,404 ****
  	}
  
  	$(document).ready(function() {
  		header_text_fields = $('.displaying-header-text');
! 		$('#pickcolor').click(function(e) {
! 			e.preventDefault();
! 			$('#color-picker').show();
  		});
- 
  		$('#display-header-text').click( toggle_text );
! 
! 		$('#defaultcolor').click(function() {
! 			pickColor(default_color);
! 			$('#text-color').val(default_color);
! 		});
! 
! 		$('#text-color').keyup(function() {
! 			var _hex = $('#text-color').val();
! 			var hex = _hex;
! 			if ( hex[0] != '#' )
! 				hex = '#' + hex;
! 			hex = hex.replace(/[^#a-fA-F0-9]+/, '');
! 			if ( hex != _hex )
! 				$('#text-color').val(hex);
! 			if ( hex.length == 4 || hex.length == 7 )
! 				pickColor( hex );
! 		});
! 
! 		$(document).mousedown(function(){
! 			$('#color-picker').each( function() {
! 				var display = $(this).css('display');
! 				if (display == 'block')
! 					$(this).fadeOut(2);
! 			});
! 		});
! 
! 		farbtastic = $.farbtastic('#color-picker', function(color) { pickColor(color); });
! 		<?php if ( display_header_text() ) { ?>
! 		pickColor('#<?php echo get_header_textcolor(); ?>');
! 		<?php } else { ?>
  		toggle_text();
! 		<?php } ?>
  	});
  })(jQuery);
  /* ]]> */
--- 345,364 ----
  	}
  
  	$(document).ready(function() {
+ 		var text_color = $('#text-color');
  		header_text_fields = $('.displaying-header-text');
! 		text_color.wpColorPicker({
! 			change: function( event, ui ) {
! 				pickColor( text_color.wpColorPicker('color') );
! 			},
! 			clear: function() {
! 				pickColor( '' );
! 			}
  		});
  		$('#display-header-text').click( toggle_text );
! 		<?php if ( ! display_header_text() ) : ?>
  		toggle_text();
! 		<?php endif; ?>
  	});
  })(jQuery);
  /* ]]> */
***************
*** 510,517 ****
  	<?php if ( $this->admin_image_div_callback ) {
  	  call_user_func( $this->admin_image_div_callback );
  	} else {
  	?>
! 	<div id="headimg" style="background-image:url(<?php esc_url ( header_image() ) ?>);max-width:<?php echo get_custom_header()->width; ?>px;height:<?php echo get_custom_header()->height; ?>px;">
  		<?php
  		if ( display_header_text() )
  			$style = ' style="color:#' . get_header_textcolor() . ';"';
--- 470,483 ----
  	<?php if ( $this->admin_image_div_callback ) {
  	  call_user_func( $this->admin_image_div_callback );
  	} else {
+ 		$custom_header = get_custom_header();
+ 		$header_image_style = 'background-image:url(' . esc_url( get_header_image() ) . ');';
+ 		if ( $custom_header->width )
+ 			$header_image_style .= 'max-width:' . $custom_header->width . 'px;';
+ 		if ( $custom_header->height )
+ 			$header_image_style .= 'height:' . $custom_header->height . 'px;';
  	?>
! 	<div id="headimg" style="<?php echo $header_image_style; ?>">
  		<?php
  		if ( display_header_text() )
  			$style = ' style="color:#' . get_header_textcolor() . ';"';
***************
*** 528,534 ****
  <tr valign="top">
  <th scope="row"><?php _e( 'Select Image' ); ?></th>
  <td>
! 	<p><?php _e( 'You can upload a custom header image to be shown at the top of your site instead of the default one. On the next screen you will be able to crop the image.' ); ?><br />
  	<?php
  	if ( ! current_theme_supports( 'custom-header', 'flex-height' ) && ! current_theme_supports( 'custom-header', 'flex-width' ) ) {
  		printf( __( 'Images of exactly <strong>%1$d &times; %2$d pixels</strong> will be used as-is.' ) . '<br />', get_theme_support( 'custom-header', 'width' ), get_theme_support( 'custom-header', 'height' ) );
--- 494,500 ----
  <tr valign="top">
  <th scope="row"><?php _e( 'Select Image' ); ?></th>
  <td>
! 	<p><?php _e( 'You can select an image to be shown at the top of your site by uploading from your computer or choosing from your media library. After selecting an image you will be able to crop it.' ); ?><br />
  	<?php
  	if ( ! current_theme_supports( 'custom-header', 'flex-height' ) && ! current_theme_supports( 'custom-header', 'flex-width' ) ) {
  		printf( __( 'Images of exactly <strong>%1$d &times; %2$d pixels</strong> will be used as-is.' ) . '<br />', get_theme_support( 'custom-header', 'width' ), get_theme_support( 'custom-header', 'height' ) );
***************
*** 546,552 ****
  			printf( __( 'Suggested height is <strong>%1$d pixels</strong>.' ) . ' ', get_theme_support( 'custom-header', 'height' ) );
  	}
  	?></p>
! 	<form enctype="multipart/form-data" id="upload-form" method="post" action="<?php echo esc_attr( add_query_arg( 'step', 2 ) ) ?>">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
--- 512,518 ----
  			printf( __( 'Suggested height is <strong>%1$d pixels</strong>.' ) . ' ', get_theme_support( 'custom-header', 'height' ) );
  	}
  	?></p>
! 	<form enctype="multipart/form-data" id="upload-form" class="wp-upload-form" method="post" action="<?php echo esc_url( add_query_arg( 'step', 2 ) ) ?>">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
***************
*** 555,567 ****
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
  	<?php
! 		$image_library_url = get_upload_iframe_src( 'image', null, 'library' );
! 		$image_library_url = remove_query_arg( 'TB_iframe', $image_library_url );
! 		$image_library_url = add_query_arg( array( 'context' => 'custom-header', 'TB_iframe' => 1 ), $image_library_url );
  	?>
  	<p>
  		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
! 		<a id="choose-from-library-link" class="button thickbox" href="<?php echo esc_url( $image_library_url ); ?>"><?php _e( 'Choose Image' ); ?></a>
  	</p>
  	</form>
  </td>
--- 521,538 ----
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
  	<?php
! 		$modal_update_href = esc_url( add_query_arg( array(
! 			'page' => 'custom-header',
! 			'step' => 2,
! 			'_wpnonce-custom-header-upload' => wp_create_nonce('custom-header-upload'),
! 		), admin_url('themes.php') ) );
  	?>
  	<p>
  		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
! 		<a id="choose-from-library-link" class="button"
! 			data-update-link="<?php echo esc_attr( $modal_update_href ); ?>"
! 			data-choose="<?php esc_attr_e( 'Choose a Custom Header' ); ?>"
! 			data-update="<?php esc_attr_e( 'Set as header' ); ?>"><?php _e( 'Choose Image' ); ?></a>
  	</p>
  	</form>
  </td>
***************
*** 570,576 ****
  </tbody>
  </table>
  
! <form method="post" action="<?php echo esc_attr( add_query_arg( 'step', 1 ) ) ?>">
  <table class="form-table">
  <tbody>
  	<?php if ( get_uploaded_header_images() ) : ?>
--- 541,547 ----
  </tbody>
  </table>
  
! <form method="post" action="<?php echo esc_url( add_query_arg( 'step', 1 ) ) ?>">
  <table class="form-table">
  <tbody>
  	<?php if ( get_uploaded_header_images() ) : ?>
***************
*** 641,667 ****
  <th scope="row"><?php _e( 'Text Color' ); ?></th>
  <td>
  	<p>
! <?php if ( display_header_text() ) : ?>
! 		<input type="text" name="text-color" id="text-color" value="#<?php echo esc_attr( get_header_textcolor() ); ?>" />
! <?php else : ?>
! 		<input type="text" name="text-color" id="text-color" value="#<?php echo esc_attr( get_theme_support( 'custom-header', 'default-text-color' ) ); ?>" />
! <?php endif; ?>
! 		<a href="#" class="hide-if-no-js" id="pickcolor"><?php _e( 'Select a Color' ); ?></a>
  	</p>
- 	<div id="color-picker" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
- </td>
- </tr>
- 
- 	<?php if ( current_theme_supports( 'custom-header', 'default-text-color' ) && get_theme_mod( 'header_textcolor' ) ) { ?>
- <tr valign="top">
- <th scope="row"><?php _e('Reset Text Color'); ?></th>
- <td>
- 	<p><?php _e( 'This will restore the original header text. You will not be able to restore any customizations.' ) ?></p>
- 	<?php submit_button( __( 'Restore Original Header Text' ), 'button', 'resettext', false ); ?>
  </td>
  </tr>
- 	<?php } ?>
- 
  </tbody>
  </table>
  <?php endif;
--- 612,631 ----
  <th scope="row"><?php _e( 'Text Color' ); ?></th>
  <td>
  	<p>
! <?php
! $header_textcolor = display_header_text() ? get_header_textcolor() : get_theme_support( 'custom-header', 'default-text-color' );
! $default_color = '';
! if ( current_theme_supports( 'custom-header', 'default-text-color' ) ) {
! 	$default_color = '#' . get_theme_support( 'custom-header', 'default-text-color' );
! 	$default_color_attr = ' data-default-color="' . esc_attr( $default_color ) . '"';
! 	echo '<input type="text" name="text-color" id="text-color" value="#' . esc_attr( $header_textcolor ) . '"' . $default_color_attr . ' />';
! 	if ( $default_color )
! 		echo ' <span class="description hide-if-js">' . sprintf( _x( 'Default: %s', 'color' ), $default_color ) . '</span>';
! }
! ?>
  	</p>
  </td>
  </tr>
  </tbody>
  </table>
  <?php endif;
***************
*** 745,751 ****
  <?php screen_icon(); ?>
  <h2><?php _e( 'Crop Header Image' ); ?></h2>
  
! <form method="post" action="<?php echo esc_attr(add_query_arg('step', 3)); ?>">
  	<p class="hide-if-no-js"><?php _e('Choose the part of the image you want to use as your header.'); ?></p>
  	<p class="hide-if-js"><strong><?php _e( 'You need Javascript to choose a part of the image.'); ?></strong></p>
  
--- 709,715 ----
  <?php screen_icon(); ?>
  <h2><?php _e( 'Crop Header Image' ); ?></h2>
  
! <form method="post" action="<?php echo esc_url(add_query_arg('step', 3)); ?>">
  	<p class="hide-if-no-js"><?php _e('Choose the part of the image you want to use as your header.'); ?></p>
  	<p class="hide-if-js"><strong><?php _e( 'You need Javascript to choose a part of the image.'); ?></strong></p>
  
***************
*** 767,773 ****
  	<p class="submit">
  	<?php submit_button( __( 'Crop and Publish' ), 'primary', 'submit', false ); ?>
  	<?php
! 	if ( isset( $oitar ) && 1 == $oitar )
  		submit_button( __( 'Skip Cropping, Publish Image as Is' ), 'secondary', 'skip-cropping', false );
  	?>
  	</p>
--- 731,737 ----
  	<p class="submit">
  	<?php submit_button( __( 'Crop and Publish' ), 'primary', 'submit', false ); ?>
  	<?php
! 	if ( isset( $oitar ) && 1 == $oitar && ( current_theme_supports( 'custom-header', 'flex-height' ) || current_theme_supports( 'custom-header', 'flex-width' ) ) )
  		submit_button( __( 'Skip Cropping, Publish Image as Is' ), 'secondary', 'skip-cropping', false );
  	?>
  	</p>
***************
*** 784,790 ****
  	 */
  	function step_2_manage_upload() {
  		$overrides = array('test_form' => false);
! 		$file = wp_handle_upload($_FILES['import'], $overrides);
  
  		if ( isset($file['error']) )
  			wp_die( $file['error'],  __( 'Image Upload Error' ) );
--- 748,760 ----
  	 */
  	function step_2_manage_upload() {
  		$overrides = array('test_form' => false);
! 
! 		$uploaded_file = $_FILES['import'];
! 		$wp_filetype = wp_check_filetype_and_ext( $uploaded_file['tmp_name'], $uploaded_file['name'], false );
! 		if ( ! wp_match_mime_types( 'image', $wp_filetype['type'] ) )
! 			wp_die( __( 'The uploaded file is not a valid image. Please try again.' ) );
! 
! 		$file = wp_handle_upload($uploaded_file, $overrides);
  
  		if ( isset($file['error']) )
  			wp_die( $file['error'],  __( 'Image Upload Error' ) );
***************
*** 819,824 ****
--- 789,797 ----
  		if ( ! current_theme_supports( 'custom-header', 'uploads' ) )
  			wp_die( __( 'Cheatin&#8217; uh?' ) );
  
+ 		if ( ! empty( $_POST['skip-cropping'] ) && ! ( current_theme_supports( 'custom-header', 'flex-height' ) || current_theme_supports( 'custom-header', 'flex-width' ) ) )
+ 			wp_die( __( 'Cheatin&#8217; uh?' ) );
+ 
  		if ( $_POST['oitar'] > 1 ) {
  			$_POST['x1'] = $_POST['x1'] * $_POST['oitar'];
  			$_POST['y1'] = $_POST['y1'] * $_POST['oitar'];
***************
*** 930,961 ****
  	}
  
  	/**
! 	 * Replace default attachment actions with "Set as header" link.
  	 *
  	 * @since 3.4.0
  	 */
! 	function attachment_fields_to_edit( $form_fields, $post ) {
! 		$form_fields = array();
! 		$href = esc_url(add_query_arg(array(
! 			'page' => 'custom-header',
! 			'step' => 2,
! 			'_wpnonce-custom-header-upload' => wp_create_nonce('custom-header-upload'),
! 			'file' => $post->ID
! 		), admin_url('themes.php')));
! 
! 		$form_fields['buttons'] = array( 'tr' => '<tr class="submit"><td></td><td><a data-location="' . $href . '" class="wp-set-header">' . __( 'Set as header' ) . '</a></td></tr>' );
! 		$form_fields['context'] = array( 'input' => 'hidden', 'value' => 'custom-header' );
! 
  		return $form_fields;
  	}
  
  	/**
! 	 * Leave only "Media Library" tab in the uploader window.
  	 *
  	 * @since 3.4.0
  	 */
! 	function filter_upload_tabs() {
! 		return array( 'library' => __('Media Library') );
  	}
  
  	/**
--- 903,923 ----
  	}
  
  	/**
! 	 * Unused since 3.5.0.
  	 *
  	 * @since 3.4.0
  	 */
! 	function attachment_fields_to_edit( $form_fields ) {
  		return $form_fields;
  	}
  
  	/**
! 	 * Unused since 3.5.0.
  	 *
  	 * @since 3.4.0
  	 */
! 	function filter_upload_tabs( $tabs ) {
! 		return $tabs;
  	}
  
  	/**
